//-----------------------------------------------------------------

function toCelsius(temp)
{
    return Math.round((temp - 32) / 1.8);
}

//-----------------------------------------------------------------

function parseTimeString(string)
{
	// parses string of the form nn:nn

	var obj = null;
	try{
		var array = string.match(/\d{1,2}/g);
		obj ={hour:parseInt(array[0], 10), minute:parseInt(array[1],10), str:string};
	}
	catch(ex){
		// ignore
	}

	return obj;
}

//-----------------------------------------------------------------

function trimWhiteSpace(string)
{
	return string.replace(/^\s*/, '').replace(/\s*$/, '');
}

//-----------------------------------------------------------------

function findChild(element, nodeName)
{
	var child;
  
	for (child = element.firstChild; child != null; child = child.nextSibling)
	{
		if (child.nodeName == nodeName)
      		return child;
  	}
  
	return null;
}

//-----------------------------------------------------------------

function ucfirst(string)
{
	var firstChar = string.charAt(0).toUpperCase();
	return firstChar + string.substr(1);
}

//-----------------------------------------------------------------

function ucwords(string) 
{
	return string.replace(
	/^(.)|\s(.)/g, 
		function($1)
    	{ 
			return $1.toUpperCase(); 
		}
	);
}

//-----------------------------------------------------------------

var filesadded="" //list of files already added

function checkloadjscssfile(filename, filetype)
{
	if (filesadded.indexOf("["+filename+"]")==-1)
	{
		loadjscssfile(filename, filetype);
		filesadded+="["+filename+"]"; //List of files added in the form "[filename1],[filename2],etc"
	}
	else
		alert("file already added!");
}

function loadjscssfile(filename, filetype)
{
	if (filetype=="js")
	{ 
		//if filename is a external JavaScript file
		var fileref=document.createElement('script');
		fileref.setAttribute("type","text/javascript");
		fileref.setAttribute("src", filename);
	}
	else if (filetype=="css")
	{ 
		//if filename is an external CSS file
		var fileref=document.createElement("link");
		fileref.setAttribute("rel", "stylesheet");
		fileref.setAttribute("type", "text/css");
		fileref.setAttribute("href", filename);
	}
	
	if (typeof fileref!="undefined")
		document.getElementsByTagName("head")[0].appendChild(fileref);
}

function createjscssfile(filename, filetype)
{
	if (filetype=="js")
	{ 
		//if filename is a external JavaScript file
		var fileref=document.createElement('script');
		fileref.setAttribute("type","text/javascript");
		fileref.setAttribute("src", filename);
	}
	else if (filetype=="css")
	{ 
		//if filename is an external CSS file
		var fileref=document.createElement("link");
		fileref.setAttribute("rel", "stylesheet");
		fileref.setAttribute("type", "text/css");
		fileref.setAttribute("href", filename);
	}
	
	return fileref;
}

function removejscssfile(filename, filetype)
{
	var targetelement=(filetype=="js")? "script" : (filetype=="css")? "link" : "none"; 	//determine element type to create nodelist from
	var targetattr=(filetype=="js")? "src" : (filetype=="css")? "href" : "none"; 		//determine corresponding attribute to test for
	var allsuspects=document.getElementsByTagName(targetelement);
	for (var i=allsuspects.length; i>=0; i--)
	{ 
		//search backwards within nodelist for matching elements to remove
		if (allsuspects[i] && allsuspects[i].getAttribute(targetattr)!=null && allsuspects[i].getAttribute(targetattr).indexOf(filename)!=-1)
			allsuspects[i].parentNode.removeChild(allsuspects[i]); //remove element by calling parentNode.removeChild()
	}
}

function replacejscssfile(oldfilename, newfilename, filetype)
{
	var targetelement=(filetype=="js")? "script" : (filetype=="css")? "link" : "none"; 	//determine element type to create nodelist using
	var targetattr=(filetype=="js")? "src" : (filetype=="css")? "href" : "none"; 		//determine corresponding attribute to test for
	var allsuspects=document.getElementsByTagName(targetelement);
	for (var i=allsuspects.length; i>=0; i--)
	{ 
		//search backwards within nodelist for matching elements to remove
		if (allsuspects[i] && allsuspects[i].getAttribute(targetattr)!=null && allsuspects[i].getAttribute(targetattr).indexOf(oldfilename)!=-1)
		{
			var newelement=createjscssfile(newfilename, filetype);
			allsuspects[i].parentNode.replaceChild(newelement, allsuspects[i]);
		}
	}
}

//-----------------------------------------------------------------

