#include <stdio.h>
#include <stdlib.h>
#include "MobileDevice.h"
#include "Shell.h"

using namespace std;

// The following is a hack so that we can write clean
// code and still use readline.  Fix but only if you grok.

COMMAND			*cur;
shell_state		*rl_sh;
char			gLASTVALUE[256];

//---

int shell(struct shell_state *sh)
{return SHELL_TERMINATE;}

int sh_help(string *args, struct shell_state *sh)
{return 0;}

int exec_line( char *line, struct shell_state *sh )
{
	int			t, count;
	size_t		i;
	COMMAND		*command = (COMMAND *)NULL;
	string		word; 
	string		*args = new string[MAX_ARGUMENTS];
	
	//strip leading white
	i = 0;
	while ( line[i] && line[i] == ' ' )
		i++;
	word = line + i;
	
	//run through *line and find spaces
	//string::size_type index;
	
	t = 0;
	count = 0;
	for( i = 0 ; i < word.length() && count < (MAX_ARGUMENTS - 1); i++)
	{
		if( word[i] == '\\' )
		{
			if ( (i+1) < word.length() )
			{
				i++;
				args[count] = args[count] + word[i];
			}
			continue;
		}
		
		if( word[i] == ' ' )
		{
			count++;
			
			while ( (i+1) < word.length() && word[i+1] == ' ' )
				i++;
				
			continue;
		}
		args[count] = args[count] + word[i];
	}
	
	// check to see if it's a valid command invocation
	for (i = 0; sh->command_array[i].name; i++)
	{
		if ( args[0].compare( sh->command_array[i].name ) == 0)
			command = &sh->command_array[i];
	}
	
	if (!command)
	{
		sprintf(gMsgStr, "shell: No such command '%s'", (char *) args[0].c_str());
		my_cout(gMsgStr, kForceOut);
		return -1;
	}
	
	// call function
	return ((*(command->func)) (args, sh));
	
	delete[] args;
	return 0;
}

bool dirExists(afc_connection *hAFC, char *path)
{
	afc_directory *hAFCDir;
	int retval = AFCDirectoryOpen(hAFC, path, &hAFCDir);

#if 0 // CHK 2007/08/11
	cout << "AFCDirectoryOpen: '" << path << "' " << ( (retval == 0) ? "found" : "not found") << endl;
#endif
	
	if(retval == 0)
		return true;
	else
		return false;
	
	//Should close dir, but AFCDirectoryClose crashes
	//AFCDirectoryClose(hAFC, &hAFCDir);
}

void processRelativePath(string *basePath, string *cdPath)
{
	// NOTE:	we assume that basePath is an absolute path.
	//		we also assume that cdPath is NOT an absolute path.
	// This function is meant to chdir basePath to cdPath
	
	string::size_type index = 0;
	string::size_type length = cdPath->length();
	string::size_type bp_end = basePath->length() - 1;
	
	if (*cdPath == "" || *cdPath == "." )
		return;
	
	while( index < length )
	{	
		//strip leading '/'
		while( index < length && cdPath->at(index) == PATH_DELIMITER_CHAR )
			index++;
		
		//stay in bounds
		if( index >= length )
			break;
		
		//Test for 'special' paths
		if( cdPath->at(index) == '.' )
		{
			index++;
			
			if( index >= length )
			{
				
			} else if( cdPath->at(index) != '.' ) {
				
				//its a '.'
				if ( cdPath->at(index) != PATH_DELIMITER_CHAR )
					index--;
				
				//break;
				
			} else {
				
				index++;
				
				if( index < length && cdPath->at(index) != PATH_DELIMITER_CHAR )
				{
					// the file name starts with '..'
					index -= 2;
				
				} else {
					
					
					if( *basePath == PATH_DELIMITER_STRING )
					{
						// cant go back on root dir
					} else {
					
						//do a '..' on basePath
						//remove initial '/'
						if( basePath->at(bp_end) == PATH_DELIMITER_CHAR )
							bp_end--;
					
						//remove until you get to another '/'
						while( bp_end > 0 && basePath->at(bp_end) != PATH_DELIMITER_CHAR )
							bp_end--;
					
						if( bp_end > 0 )
						{
							*basePath = basePath->substr(0,bp_end);
							bp_end = basePath->length() - 1;
						} else {
							*basePath = PATH_DELIMITER_STRING;
							bp_end = 0;
						}
					
					}
				}
			}
		}
		
		if( basePath->at(bp_end) != PATH_DELIMITER_CHAR )
		{
			*basePath += PATH_DELIMITER_CHAR;
			bp_end++;
		}
		
		while( index < length && cdPath->at(index) != PATH_DELIMITER_CHAR )
		{
			
			if( cdPath->at(index) != '\\' )
			{
				*basePath += cdPath->at(index);
				bp_end++;
				index++;
			} else {
				index++;
			}
		}
	}
	
	//if there is a trailing / on the end of cdPath, add it
	//as long as there isn't already one at the end of basePath
	if(	basePath->at(basePath->length() - 1) != PATH_DELIMITER_CHAR && cdPath->at(cdPath->length() - 1 ) == PATH_DELIMITER_CHAR )
		*basePath += PATH_DELIMITER_CHAR;
}

/* -*- mode:c; indent-tabs-mode:nil; c-basic-offset:2; tab-width:2; */
